package ar.rulosoft.mimanganu.servers;

import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import ar.rulosoft.mimanganu.R;
import ar.rulosoft.mimanganu.componentes.Capitulo;
import ar.rulosoft.mimanganu.componentes.Manga;
import ar.rulosoft.navegadores.Navegador;

public class EsNineMangaCom extends ServerBase {

	public static String[] generos = new String[] { "Accin", "Action", "Adult", "Adventure", "Artes Marciales", "Aventura", "Ciencia FicciN", "Comedia",
			"Comedy", "Deporte", "Deportes", "Drama", "Ecchi", "Escolar", "FantasA", "Fantasy", "Gender Bender", "Genial", "Harem", "Historical", "HistRico",
			"Horror", "Josei", "Maduro", "Martial", "Martial Arts", "Mecha", "Misterio", "Mystery", "None", "One Shot", "Oneshot", "Parodia", "PsicolGico",
			"Psychological", "Romance", "School Life", "Sci-Fi", "Seinen", "Shojo", "Shojo Ai", "Shonen", "Shoujo", "Shoujo Ai", "Shounen", "Shounen Ai",
			"Slice Of Life", "Smut", "Sobrenatural", "Sports", "Supernatural", "Tragedia", "Tragedy", "Vida Cotidiana", "Webcomic", "Yuri" };
	public static String[] generosV = new String[] { "http://es.ninemanga.com/category/Acci%C3%B3n_.html", "http://es.ninemanga.com/category/Action_.html",
			"http://es.ninemanga.com/category/Adult_.html", "http://es.ninemanga.com/category/Adventure_.html",
			"http://es.ninemanga.com/category/Artes+Marciales_.html", "http://es.ninemanga.com/category/Aventura_.html",
			"http://es.ninemanga.com/category/Ciencia+Ficci%C3%B3n_.html", "http://es.ninemanga.com/category/Comedia_.html",
			"http://es.ninemanga.com/category/Comedy_.html", "http://es.ninemanga.com/category/Deporte_.html",
			"http://es.ninemanga.com/category/Deportes_.html", "http://es.ninemanga.com/category/Drama_.html", "http://es.ninemanga.com/category/Ecchi_.html",
			"http://es.ninemanga.com/category/Escolar_.html", "http://es.ninemanga.com/category/Fantas%C3%ADa_.html",
			"http://es.ninemanga.com/category/Fantasy_.html", "http://es.ninemanga.com/category/Gender+Bender_.html",
			"http://es.ninemanga.com/category/Genial_.html", "http://es.ninemanga.com/category/Harem_.html",
			"http://es.ninemanga.com/category/Historical_.html", "http://es.ninemanga.com/category/Hist%C3%B3rico_.html",
			"http://es.ninemanga.com/category/Horror_.html", "http://es.ninemanga.com/category/Josei_.html", "http://es.ninemanga.com/category/Maduro_.html",
			"http://es.ninemanga.com/category/Martial_.html", "http://es.ninemanga.com/category/Martial+Arts_.html",
			"http://es.ninemanga.com/category/Mecha_.html", "http://es.ninemanga.com/category/Misterio_.html",
			"http://es.ninemanga.com/category/Mystery_.html", "http://es.ninemanga.com/category/None_.html", "http://es.ninemanga.com/category/One+Shot_.html",
			"http://es.ninemanga.com/category/Oneshot_.html", "http://es.ninemanga.com/category/Parodia_.html",
			"http://es.ninemanga.com/category/Psicol%C3%B3gico_.html", "http://es.ninemanga.com/category/Psychological_.html",
			"http://es.ninemanga.com/category/Romance_.html", "http://es.ninemanga.com/category/School+Life_.html",
			"http://es.ninemanga.com/category/Sci-fi_.html", "http://es.ninemanga.com/category/Seinen_.html", "http://es.ninemanga.com/category/Shojo_.html",
			"http://es.ninemanga.com/category/Shojo+Ai_.html", "http://es.ninemanga.com/category/Shonen_.html",
			"http://es.ninemanga.com/category/Shoujo_.html", "http://es.ninemanga.com/category/Shoujo+Ai_.html",
			"http://es.ninemanga.com/category/Shounen_.html", "http://es.ninemanga.com/category/Shounen+Ai_.html",
			"http://es.ninemanga.com/category/Slice+Of+Life_.html", "http://es.ninemanga.com/category/Smut_.html",
			"http://es.ninemanga.com/category/Sobrenatural_.html", "http://es.ninemanga.com/category/Sports_.html",
			"http://es.ninemanga.com/category/Supernatural_.html", "http://es.ninemanga.com/category/Tragedia_.html",
			"http://es.ninemanga.com/category/Tragedy_.html", "http://es.ninemanga.com/category/Vida+Cotidiana_.html",
			"http://es.ninemanga.com/category/Webcomic_.html", "http://es.ninemanga.com/category/Yuri_.html" };

	public EsNineMangaCom() {
		this.setBandera(R.drawable.flag_esp);
		this.setIcon(R.drawable.esninemanga);
		this.setServerName("EsNineManga");
		setServerID(ServerBase.ESNINEMANGA);
	}

	@Override
	public ArrayList<Manga> getMangas() throws Exception {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public ArrayList<Manga> getBusqueda(String termino) throws Exception {
		String source = new Navegador().get("http://es.ninemanga.com/search/?wd=" + URLEncoder.encode(termino, "UTF-8"));
		ArrayList<Manga> mangas = new ArrayList<Manga>();
		Pattern p = Pattern.compile("l\"><img src=\"(.+?)\"/>.+?href=\"(.+?)\">(.+?)<");
		Matcher m = p.matcher(source);
		while (m.find()) {
			Manga manga = new Manga(ESNINEMANGA, m.group(3), "http://es.ninemanga.com" + m.group(2), false);
			manga.setImages(m.group(1));
			mangas.add(manga);
		}
		return mangas;
	}

	@Override
	public void cargarCapitulos(Manga m) throws Exception {
		if (m.getCapitulos() == null || m.getCapitulos().size() == 0)
			cargarPortada(m);
	}

	@Override
	public void cargarPortada(Manga m) throws Exception {
		String source = new Navegador().get(m.getPath());
		
		// captulos
		Pattern p = Pattern.compile("<a class=\"chapter_list_a\" href=\"(/chapter.+?)\" title=\"(.+?)\">(.+?)</a>");
		Matcher matcher = p.matcher(source);
		ArrayList<Capitulo> capitulos = new ArrayList<Capitulo>();
		while (matcher.find()) {
			capitulos.add(new Capitulo(matcher.group(3), "http://es.ninemanga.com" + matcher.group(1)));
		}
		m.setCapitulos(capitulos);
		
		// portada
		String portada = getFirstMacth("src=\"([^\"]+)\"/>", source, "Error al obtener la portada");
		m.setImages(portada);
		// sinopsis
		try {
			String sinopsis = getFirstMacth("<p itemprop=\"description\">(.+?)&nbsp;Show less", source, "Erros al obtener sinopsis").replaceAll("<.?>", "");
			m.setSinopsis(sinopsis);
		} catch (Exception e) {
			m.setSinopsis("Sin Sinopsis");
		}
	}

	@Override
	public String getPagina(Capitulo c, int pagina) {
		return c.getPath().replace(".html", "-" + pagina + ".html");
	}

	@Override
	public String getImagen(Capitulo c, int pagina) throws Exception {
		String source = new Navegador().get(getPagina(c, pagina));
		return getFirstMacth("<img class=\"manga_pic.+?src=\"([^\"]+)", source, "Error al obtener imagen");
	}

	@Override
	public void iniciarCapitulo(Capitulo c) throws Exception {
		String source = new Navegador().get(c.getPath());
		String nop = getFirstMacth("\\d+/(\\d+)</option></select>", source, "Error al obtener el nmero de pginas");
		c.setPaginas(Integer.parseInt(nop));
	}

	@Override
	public ArrayList<Manga> getMangasFiltered(int categoria, int ordentipo, int pagina) throws Exception {
		String source = new Navegador().get(generosV[categoria].replace("_", "_" + pagina));
		return getMangasFromSource(source);
	}

	public ArrayList<Manga> getMangasFromSource(String source) {
		ArrayList<Manga> mangas = new ArrayList<Manga>();
		Pattern p = Pattern.compile("<dl class=\"bookinfo\"><dt><a href=\"(/manga/.+?)\"><img src=\"(.+?)\" alt=\"(.+?)\"/>");
		Matcher m = p.matcher(source);
		while (m.find()) {
			Manga manga = new Manga(ESNINEMANGA, m.group(3), "http://es.ninemanga.com" + m.group(1), false);
			manga.setImages(m.group(2));
			mangas.add(manga);
		}
		return mangas;
	}

	@Override
	public String[] getCategorias() {
		return generos;
	}

	@Override
	public String[] getOrdenes() {
		return new String[] { "Popularidad" };
	}

	@Override
	public boolean tieneListado() {
		return false;
	}

}
